﻿using UnityEngine;
using System.Collections;

public class AudioSampler : MonoBehaviour
{

    public float[] freqValues;
    public float freqStartThreshold = 0.4f;
    public float freqEndThreshold = 0.7f;

    float[] freqData = new float[8192];
    AudioSource audioSource;
    float[] band;

    void Start()
    {
        audioSource = GetComponent<AudioSource>();

        int n = freqData.Length;
        int k = 0;
        for (var j = 0; j < freqData.Length; j++)
        {
            n /= 2;
            if (n == 0) break;
            k++;
        }
        band = new float[k + 1];
        freqValues = new float[k + 1];

        int freqStart = (int)(freqValues.Length * freqStartThreshold);
        int freqEnd = (int)(freqValues.Length * freqEndThreshold);

        for (var i = 0; i < band.Length; i++)
        {
            band[i] = 0;
        }
        StartCoroutine(Check());
    }

    IEnumerator Check()
    {
        while (true)
        {
            audioSource.GetSpectrumData(freqData, 0, FFTWindow.Rectangular);
            int k = 0;
            int crossover = 2;
            for (int i = 0; i < freqData.Length; i++)
            {
                var d = freqData[i];
                var b = band[k];
                band[k] = (d > b) ? d : b;   // find the max as the peak value in that frequency band.
                if (i > crossover - 3)
                {
                    k++;
                    crossover *= 2;   // frequency crossover point for each band.
                    float y = band[k] * 32;
                    freqValues[k] = band[k];
                    band[k] = 0;
                }
            }
            yield return new WaitForFixedUpdate();
        }
    }
}