﻿using UnityEngine;
using System.Collections;

public class controller : MonoBehaviour
{

    public float speed = 1;
    public float minX = -1;
    public float maxX = 1;
    public int positionsCount = 6;
    public float normalizedPosition;
    private float targetPosition;
    private int currentIndex;

    void Start()
    {
        currentIndex = 0;
        targetPosition = minX;
    }

    public void MoveLeft()
    {
        currentIndex--;
        UpdateTargetPosition();
    }

    public void MoveRight()
    {
        currentIndex++;
        UpdateTargetPosition();
    }

    private void UpdateTargetPosition()
    {
        currentIndex = Mathf.Clamp(currentIndex, 0, positionsCount - 1);
        normalizedPosition = currentIndex / ((float)positionsCount - 1);
        targetPosition = minX + (normalizedPosition) * (maxX - minX);
    }

    void Update()
    {
        if (Input.GetKeyDown(KeyCode.LeftArrow))
        {
            MoveLeft();
        }
        if (Input.GetKeyDown(KeyCode.RightArrow))
        {
            MoveRight();
        }

        if (Mathf.Abs(this.transform.localPosition.x - targetPosition) > 0.01)
        {
            int direction = this.transform.localPosition.x < targetPosition ? 1 : -1;

            var newXPosition = this.transform.localPosition.x + direction * speed * Time.deltaTime;
            if (direction > 0 && newXPosition > targetPosition)
                newXPosition = targetPosition;
            if (direction < 0 && newXPosition < targetPosition)
                newXPosition = targetPosition;

            this.transform.localPosition = new Vector3(newXPosition, this.transform.localPosition.y, this.transform.localPosition.z);
        }
    }
}
